/* src/aide.c - Aide
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <ctype.h>
#include <main.h>

CVSINFO("$Id: aide.c,v 1.2 2003/02/09 13:50:00 romexzf Exp $");

/* Note: Les fonctions suivantes ont t reprises du CS5.0  IRCore.
 *       Elles ont t adapts pour ces services.
 */

extern struct cs_commands cs_cmds[];

void syntax_cmd(aNick *nick, int index)
{
	int i = GetCmdIndexbyName("AIDE");
	csntc(nick, cs_cmds[index].syntax, "Syntaxe:", cs_cmds[index].cmd);
	csntc(nick, "Tapez \002/%s %s %s\002 pour plus d'informations.", cs.nick, cs_cmds[i].cmd, cs_cmds[index].realcmd);
	return;
}

void aide(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	FILE *fp;
	char buffer[402], tbuf[500], cmdhelp[100], ptr[50], *ptr1 = NULL;
	int i=0;

	buffer[0] = '\0';
	tbuf[0]='\0';
	cmdhelp[0]='\0';
	ptr[0] = '\0';

	if(parc < 1)
	{
		sprintf(cmdhelp, "aide/SHOWCOMMANDS");
		if(!(fp = fopen(cmdhelp, "r")))
		{
			csntc(nick, "Erreur interne, consultez un Administrateur.");
			return;
		}
		while(fgets(buffer, 400, fp))
		{
			translate_esc(buffer, tbuf, parv[0]);
			csntc(nick, "%s", tbuf);
		}
		fclose(fp);
		return;
	}

	strncpy(ptr, parv[1], 50);
	if(!isalpha(*parv[1]))
	{
		csntc(nick, "\2Caractre invalide.");
		return;
	}

	if((ptr1 = strchr(ptr, ' '))) *ptr1++ = '\0';
	strupr(ptr);
	snprintf(cmdhelp, 100, "aide/%s", ptr);

	if(!(fp = fopen(cmdhelp, "r")))
	{
		csntc(nick, "\2Cette commande n'existe pas (ou aide non trouve).");
		return;
	}
	csntc(nick, "   --[ \2\0032Aide sur\0033 %s\3\2 ]--", ptr);

	while(fgets(buffer, 400, fp))
	{
		if(i==1)
		for (i=0; cs_cmds[i].cmd[0] != '\0'; i++)
		if (!strcasecmp(cs_cmds[i].cmd, ptr))
		csntc(nick, "Niveau: \2\003%s\002\003 %d\n", (cs_cmds[i].level > 1) ? (cs_cmds[i].level <5) ? "4ADMIN" : "2CHAN" : "3USER" , cs_cmds[i].level);
		translate_esc(buffer, tbuf, parv[0]);
		csntc(nick, "%s", tbuf);
		i++;
	}
	csntc(nick, "   Vous pouvez demander plus d'informations sur %s\n", bot.chan);
	fclose(fp);
}

void translate_esc(char *buffer, char *tbuffer, char *botnick)
{
   int i = 0, j = 0, k = 0;
   while(buffer[i] != '\0')
   {
      if(buffer[i] == '\\')
      {
         switch(buffer[i+1])
         {
         case 'b':
            tbuffer[k] = '\037';
            break;
         case 'i':
            tbuffer[k] = '\026';
            break;
         case 'r':
            tbuffer[k] = ' ';
            break;
         case 'n':
            while(botnick[j] != '\0')
            {
               tbuffer[k] = botnick[j];
               k++;
               j++;
            }
            k--;
            break;
         case 'c':
            while(bot.chan[j] != '\0')
            {
               tbuffer[k] = bot.chan[j];
               k++;
               j++;
            }
            k--;
            break;
         }
         i+=2;
         k++;
         continue;
      }
      tbuffer[k] = buffer[i];
      i++;
      k++;
   }
   tbuffer[k] = '\0';
}
