/* src/chaninfo.c - Lire les informations  propos d'un salon
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <main.h>

CVSINFO("$Id: chaninfo.c,v 1.3 2003/02/16 14:08:28 romexzf Exp $");

/*
 * chaninfo
 *
 * parv[1] = #salon
 */

void chaninfo(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
  aLink *lp;
  char options[300], tmp[300], mask[20], buf[400];

  tmp[0] = '\0';

  for(lp=chaninfo->access;lp && lp->value.a->level != 500;lp=lp->next);
  csntc(nick, "------------------[ \0032\002%s\002\0036 > Informations\003         ]------------------", parv[1]);
  csntc(nick, "\002Fondateur     :\002 %s", lp ? lp->value.a->user->nick : "Aucun");
  csntc(nick, "\002Description   :\002 %s", chaninfo->description);
  if(IsAnAdmin(nick->user) || !strchr(chaninfo->defmodes, 'k'))
    csntc(nick, "\002Defmodes      :\002 %s", chaninfo->defmodes);
  else
  {
	  char *tmp2=NULL;
	  tmp2=chaninfo->defmodes;
	  strtok(tmp2, " ");
	  csntc(nick, "\002Defmodes      :\002 %s", tmp2);
  }

  csntc(nick, "\002Deftopic      :\002 %s", chaninfo->deftopic);
  if(IsAnAdmin(nick->user)) csntc(nick, "\002Motd          :\002 %s", chaninfo->motd);
  if(IsAnAdmin(nick->user) && CWantUnreg(chaninfo)) csntc(nick, "\2Salon en procdure d'Unreg\2");
  csntc(nick, "\002Url du salon  :\002 %s", chaninfo->url);

  options[0]='\0';
  if(CLockTopic(chaninfo)) strncat(options, " locktopic", 300);
  if(CNoOps(chaninfo)) strncat(options, " noops", 300);
  if(CNoBans(chaninfo)) strncat(options, " nobans", 300);
  if(CStrictOp(chaninfo)) strncat(options, " strictop", 300);
  if(CSetWelcome(chaninfo)) strncat(options, " welcome", 300);
  if(CAutoInvite(chaninfo)) strncat(options, " autoinvite", 300);
  if(chaninfo->suspend[0] != '\0') strncat(options, " suspendu", 300);
  csntc(nick, "\002Options       :\002%s", options[0] != '\0' ? options : " Aucunes");
  csntc(nick, "\002Banlevel      :\002 %d", chaninfo->banlevel);
  switch(chaninfo->bantype)
  {
	  case 1: strcpy(mask, "*!*ident@*.host"); break;
	  case 2: strcpy(mask, "*!*ident@*"); break;
	  case 3: strcpy(mask, "*nick*!*@*"); break;
	  case 4: strcpy(mask, "*!*@host"); break;
	  default: strcpy(mask, "<aucun>");
  }

  csntc(nick, "\002Bantype       :\002 %s", mask);
  if(CSetWelcome(chaninfo)) csntc(nick, "\002Welcome       :\002 %s", chaninfo->welcome);
  if(chaninfo->suspend[0] != '\0') csntc(nick, "\002Suspendu      :\002 %s", chaninfo->suspend);
  csntc(nick, "\002Topic actuel  :\002 %s", chaninfo->topic);
  csntc(nick, "\002Modes actuels :\002 %s", chaninfo->modes);
  if(chaninfo->key[0] != '\0' && IsAnAdmin(nick->user)) csntc(nick, "\2Clef de salon :\2 %s", chaninfo->key);
  if(IsAnAdmin(nick->user))
  {
  	int first=1;
	buf[0]='\0';
  	for(lp=chaninfo->members;lp;lp=lp->next)
	{
		if((strlen(buf) + strlen(lp->value.j->nick->nick)) >= 385)
		{
			if(first)
			{
				csntc(nick, "\002Users du salon:\002%s", buf);
				first=0;
			}
			else csntc(nick, "              :%s", buf);
			buf[0]='\0';
		}
		snprintf(tmp, (NICKLEN + 15), " %s%s%s%s%s", lp->value.j->nick->is_oper?"\0037\2*\003\2":"",lp->value.j->nick->user?"\0035!\003":"", lp->value.j->is_op ? "@" : "", lp->value.j->is_voice ? "+" : "",lp->value.j->nick->nick);
		strncat(buf, tmp, 400);
	}
	if(first && buf[0]!='\0') csntc(nick, "\002Users du salon:\002%s", buf);
	else if(buf[0]!='\0') csntc(nick, "              :%s", buf);
  }
  csntc(nick, "-");
  csntc(nick, "Utilisez la commande BANLIST pour voir les bans, et la commande ACCESS pour la liste des accs au salon.");
  return;
}
