/* src/chanopt.c - Paramtrage des options salons
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <main.h>

CVSINFO("$Id: chanopt.c,v 1.2 2003/02/16 14:08:28 romexzf Exp $");

/*
 * generic_chanopt
 *
 * parv[1] = #salon
 * parv[2] = option
 * parv[3] = argument
 */
void generic_chanopt(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	if(!strcasecmp(parv[2], "setwelcome"))
	{
		if(CSetWelcome(chaninfo)) DelCSetWelcome(chaninfo);
		else SetCSetWelcome(chaninfo);
		csntc(nick, "Le message de bienvenue a t %sactive sur le chan \002%s\002.",\
		CSetWelcome(chaninfo) ? "" : "des", parv[1]);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(parv[2], "defmodes"))

	{
		char *mode;
		int a=0;
		if(parc < 3)
		{
			csntc(nick, "Syntaxe incorrecte !");
			csntc(nick, "CHANOPT #salon DEFMODES modes");
			return;
		}

		if(!(parv[3][0] == '+') || strchr(parv[3],'-'))
		{
			csntc(nick, "Veuillez prciser des modes valides");
			return;
		}
		mode=parv[3];
		if(strchr(mode, 'o') || strchr(mode, 'b') || strchr(mode, 'v'))
		{
			csntc(nick, "Vous n'tes pas autoris  changer les Ops,Voices,Bans avec cette commande.");
			return;
		}
		if(!nick->is_oper && strchr(mode, 'O'))
		{
			csntc(nick, "Vous n'tes pas autoris  changer ce mode (O)");
			return;
		}
		if(strchr(mode, 'k')) a++;
		if(strchr(mode, 'l')) a++;

		snprintf(chaninfo->defmodes, 30, "%s %s %s", mode, (a && parc > 3) ? parv[4] : "", (a>1 && parc > 4) ? parv[5] : "");
		csntc(nick, "Les modes par defaut sont maintenant \002%s\002 sur le chan \002%s\002.", parv[3], parv[1]);
		csmode(chaninfo ,"-ntskilpmcCOr *");
		csmode(chaninfo ,"%s", chaninfo->defmodes);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(parv[2], "welcome"))
	{
		if(parc < 3)
		{
			csntc(nick, "Syntaxe incorrecte !");
			csntc(nick, "CHANOPT #salon WELCOME message");
			return;
		}
		if(!strcasecmp(parv[3], "none"))
		{
			chaninfo->welcome[0] = '\0';
			DelCSetWelcome(chaninfo);
			csntc(nick, "Le welcome sur \002%s\002 est supprim.", parv[1]);
			write_achan(chaninfo);
			return;
		}
		parv2msgn(parc, parv, 3, chaninfo->welcome, 250);
		csntc(nick, "Le message de bienvenue sur \002%s\002 est maintenant : %s", parv[1], chaninfo->welcome);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(parv[2], "deftopic"))
	{
		if(parc < 3)
		{
			csntc(nick, "Syntaxe incorrecte !");
			csntc(nick, "CHANOPT #salon DEFTOPIC topic");
			return;
		}
		if(CLockTopic(chaninfo))
		{
			csntc(nick, "Le LOCKTOPIC est actif sur %s", parv[1]);
			write_achan(chaninfo);
			return;
		}
		parv2msgn(parc, parv, 3, chaninfo->deftopic, TOPICLEN);
		csntc(nick, "Le topic par defaut sur \002%s\002 est maintenant : %s", parv[1], chaninfo->deftopic);
		cstopic(chaninfo, "%s", chaninfo->deftopic);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(parv[2], "motd"))
	{
		if(parc < 3)
		{
			csntc(nick, "Syntaxe incorrecte !");
			csntc(nick, "CHANOPT #salon MOTD motd");
			return;
		}
		if(!strcasecmp(parv[3], "none"))
		{
			chaninfo->motd[0] = '\0';
			csntc(nick, "Le motd sur \002%s\002 est supprim.", parv[1]);
			write_achan(chaninfo);
			return;
		}
		parv2msgn(parc, parv, 3, chaninfo->motd, 250);
		csntc(nick, "Le message du jour de \002%s\002 est maintenant: %s", parv[1], chaninfo->motd);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(parv[2], "description"))
	{
		if(parc < 3)
		{
			csntc(nick, "Syntaxe incorrecte !");
			csntc(nick, "CHANOPT #salon DESCRIPTION description");
			return;
		}
		parv2msgn(parc, parv, 3, chaninfo->description, 200);
		csntc(nick, "La description pour \002%s\002 est maintenant: %s", parv[1], chaninfo->description);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(parv[2], "chanurl"))
	{
		if(parc < 3)
		{
			csntc(nick, "Syntaxe incorrecte !");
			csntc(nick, "CHANOPT #salon chanurl <url>");
			return;
		}
		if(!strchr(parv[3], '.'))
		{
			csntc(nick, "C'est une url que vous devez mettre ici !");
			return;
		}
		strncpy(chaninfo->url, parv[3], 200);
		csntc(nick, "L'url de \002%s\002 est maintenant: %s", parv[1], chaninfo->url);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(parv[2], "banlevel"))
	{
		int l = ChanLevelbyUserI(nick->user, parv[1]), n;
		if(parc < 3)
		{
			csntc(nick, "Syntaxe incorrecte !");
			csntc(nick, "CHANOPT #salon BANLEVEL <niveau>");
			return;
		}
		if(!is_num(parv[3]))
		{
			csntc(nick, "Le niveau doit tre un nombre.");
			return;
		}
		n = atoi(parv[3]);
		if((n > l || chaninfo->banlevel > l) && nick->user->level < 2)
		{
			csntc(nick, "Vous ne pouvez changer le banlevel s'il est  un niveau suprieur au votre, ou a un niveau suprieur.");
			return;
		}
		chaninfo->banlevel = n;
		csntc(nick, "Le banlevel pour \002%s\002 est maintenant: %d", parv[1], chaninfo->banlevel);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(parv[2], "bantype"))
	{
		int t;
		char mask[20];
		if(parc < 3)
		{
			csntc(nick, "Syntaxe: CHANOPT #salon BANTYPE <n du type>");
			return;
		}
		if(!is_num(parv[3]))
		{
			csntc(nick, "Le type de ban doit tre dfini en prcisant un nombre");
			return;
		}
		t = atoi(parv[3]);
		if(t > 4 || t < 1)
		{
			csntc(nick, "Il n'y a que 4 types de bans.");
			csntc(nick, "Voici les diffrents types de bans :");
			csntc(nick, " \0021.\002 Ban sur *!*ident@*.host");
			csntc(nick, " \0022.\002 Ban sur *!*ident@*");
			csntc(nick, " \0023.\002 Ban sur *nick*!*@*");
			csntc(nick, " \0024.\002 ban sur *!*@host");
			return;
		}
		chaninfo->bantype = t;
		switch(t)
		{
			case 1: strcpy(mask, "*!*ident@*.host"); break;
			case 2: strcpy(mask, "*!*ident@*"); break;
			case 3: strcpy(mask, "*nick*!*@*"); break;
			case 4: strcpy(mask, "*!*@host"); break;
			default: strcpy(mask, "<invalide>");
		}
		csntc(nick, "Le type de ban est maintenant sur \002%s\002. (%d)", mask, t);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(parv[2], "strictop"))
	{
		chaninfo->flag = ToggleFlag(chaninfo->flag, C_STRICTOP);
		csntc(nick, "Le STRICTOP a t %sactiv sur %s.", CStrictOp(chaninfo) ? "" : "des", parv[1]);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(parv[2], "locktopic"))
	{
		chaninfo->flag = ToggleFlag(chaninfo->flag, C_LOCKTOPIC);
		csntc(nick, "Le LOCKTOPIC a t %sactiv sur %s.", CLockTopic(chaninfo) ? "" : "des", parv[1]);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(parv[2], "nobans"))
	{
		chaninfo->flag = ToggleFlag(chaninfo->flag, C_NOBANS);
		csntc(nick, "Le NOBANS a t %sactiv sur %s.", CNoBans(chaninfo) ? "" : "des", parv[1]);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(parv[2], "noops"))
	{
		chaninfo->flag = ToggleFlag(chaninfo->flag, C_NOOPS);
		csntc(nick, "Le NOOPS a t %sactiv sur %s.", CNoOps(chaninfo) ? "" : "des", parv[1]);
		write_achan(chaninfo);
		return;
	}
	if(!strcasecmp(parv[2], "autoinvite"))
	{
		chaninfo->flag = ToggleFlag(chaninfo->flag, C_AUTOINVITE);
		csntc(nick, "L'AUTOINVITE a t %sactiv sur %s.", CAutoInvite(chaninfo) ? "" : "des", parv[1]);
		write_achan(chaninfo);
		return;
	}
	csntc(nick, "%s n'est pas une option de chanopt valide.", parv[2]);
	return;
}

void locktopic(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];
	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "locktopic";
	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void strictop(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];
	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "strictop";
	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void nobans(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];
	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "nobans";
	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void noops(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];
	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "noops";
	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void activwelcome(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];
	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "setwelcome";
	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void deftopic(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[100];
	int i;

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "deftopic";
	for(i=2;i<=parc;i++)
		pparv[i+1]=parv[i];

	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void defmodes(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[100];
	int i;

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "defmodes";
	for(i=2;i<=parc;i++)
		pparv[i+1]=parv[i];

	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void description(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[100];
	int i;

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "description";
	for(i=2;i<=parc;i++)
		pparv[i+1]=parv[i];

	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void csetwelcome(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[100];
	int i;

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "welcome";
	for(i=2;i<=parc;i++)
		pparv[i+1]=parv[i];

	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void banlevel(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "banlevel";
	if(parc == 2) pparv[3]=parv[2];

	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void bantype(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[5];

	pparv[0] = parv[0]; // botnick
	pparv[1] = parv[1]; // chan
	pparv[2] = "bantype"; // cmd
	if(parc == 2) pparv[3] = parv[2]; // type

	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void define_motd(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[100];
	int i;

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "motd";
	for(i=2;i<=parc;i++)
		pparv[i+1]=parv[i];

	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}

void chanurl(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *pparv[100];

	pparv[0] = parv[0];
	pparv[1] = parv[1];
	pparv[2] = "chanurl";
	pparv[3] = parv[2];

	generic_chanopt(nick, chaninfo, parc + 1, pparv);
	return;
}
