/* src/nickserv.c - Diverses commandes sur le module nickserv
 * Copyright (C) 2002-2003 Inter System (Progs@Inter-System.Net)
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <main.h>
#include <unistd.h>
#include <time.h>
#include <stdarg.h>
#include <ctype.h>

CVSINFO("$Id: nickserv.c,v 1.9 2003/02/16 18:42:29 romexzf Exp $");

extern const int ConfFlag;
extern const char HIDDEN_HOST[];
extern char *network;
extern const char *mailprog;
extern const int ConfFlag;
extern const int kill_interval;
char user_motd[400];
char admin_motd[400];

void cswall(const char *msg, ...)
{
	aNick *n;
	char buf[512];

	va_list vl;
	va_start(vl, msg);
	vsnprintf(buf, 512, msg, vl);
	va_end(vl);

	for(n=nickhead;n;n=n->next) if(n->user && IsAnAdmin(n->user)) csntc(n, buf);
	return;
}

void hello_world(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	struct userinfo *user;
	char passwd[20], memo[MEMOLEN], p[15], dur[230];
	int flag=0;

	if(!premiere)
	{
		csntc(nick, "Hello ! L'owner des services a dj t dfini");
		return;
	}
	if(parc < 2)
	{
		csntc(nick, "La syntaxe est: /%s HELLO <login> <mail> <pass>", cs.nick);
		return;
	}
	strcpy(p, parv[3]);
	if ((user = getuserinfo(parv[1])))
	{
		duration(time(NULL) - user->lastseend, dur);
		csntc(nick, "%s est dj un UserName enregistr. (Dernire visite il y a %s)", user->nick, dur);
		return;
	}
	if(nick->user)
	{
		csntc(nick, "Vous tes dj identifi sous l'username \002%s\002, et vous ne pouvez avoir plus d'un username.", nick->user);
		return;
	}
	if(strlen(parv[2]) > 140)
	{
		csntc(nick, "Le mail est limit  140 charactres.");
		return;
	}
	if(!IsValidMail(parv[2]))
	{
		csntc(nick, "Veuillez entrer un email correct.");
		return;
	}
	strcpy(passwd, mkpass(p, "lala"));

	flag |= (U_NOPURGE | U_POKACCESS);

	user=add_regnick(parv[1], passwd, time(NULL), 4, flag, 0, parv[2], 0);

	flag = 0; /* reset pour access flag */
	flag |= (A_OP | A_VOICE | A_PROTECT);

#ifdef USE_MEMOSERV
	snprintf(memo, MEMOLEN, "Bienvenue sur les services CoderZ. Vous pouvez avoir la liste de leurs commandes en tapant \037/%s showcommands\037.", cs.nick);
	add_memo(user, "Services", time(NULL), memo);
#endif

	csntc(nick, "Hello ! Vous tes bien reconnu comme administrateur des services CoderZ");
	csntc(nick, "Vous tes de niveau 4, qui est le plus grand niveau admin. Le niveau 0 est le niveau non enregistr, niveau 1 niveau user normal identifi, et de 2  4 admin");
	csntc(nick, "Veuillez lire README pour plus d'informations");

#ifdef USE_CHANSERV
	chaninfo = add_chan(bot.chan, "+nt", "Salon d'aide  propos des services CoderZ", "Salon d'aide  propos des services CoderZ", "+nt", "Salon d'aide  propos des services CoderZ", "Bienvenue sur le salon d'aide aux services CoderZ", 1, "", 0, 0, 0, 0, 100, 1, "Vous pouvez aider nos users !", network);
	add_access(user, bot.chan, 500, flag, "Je suis l'owner des services", time(NULL));
	csjoin(chaninfo);
	csmode(chaninfo, "+ont %s", cs.num);
	csntc(nick, "Le salon %s vient d'tre enregistr sous votre pseudo", bot.chan);
	putlog(LOG_CHANS, "HELLO %s par %s (%s)\n", bot.chan, nick->nick, "Salon d'aide  propos des services CoderZ");
	write_chanlist();
	write_achan(chaninfo);
#endif /* USE_CHANSERV */

	csntc(nick, "Vous avez enregistr votre username (%s).", parv[1]);
	csntc(nick, "Votre nick devient votre UserName et sera utilis pour tous vos accs aux services.");
	csntc(nick, "Pour vous identifier  TOUS les services, il suffit de taper /%s LOGIN %s %s", cs.nick, parv[1], "<pass>");
	append_file(USERS_FILE,user->nick);
	write_anuser(user);
	premiere = 0;
	return;
}
#undef RAND_MAX
#define RAND_MAX 23456789

void register_user(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	struct userinfo *user;
	char passwd[20], memo[MEMOLEN], p[15], dur[230];
	int flag = 0;
	time_t current = time(NULL);
#ifndef ADMINREG
	FILE *fm;
	int i = 0, j;
	char c, mail[150], dir[50];
#endif

#ifdef ADMINREG
	if(!nick->user || !IsAnAdmin(nick->user))
	{
		csntc(nick, "Le CServ est configur pour que les enregistrements d'username ne soit fait que par des Admins.");
		csntc(nick, "Consultez les pour plus d'informations");
		return;
	}
#else
	if(!strcasecmp(mailprog, "nomail"))
	{
#endif
		if(parc < 3)
		{
			csntc(nick, "Veuillez spcifier un mot de passe.");
			return;
		}
		if(strlen(parv[3]) < 6 || strlen(parv[3]) > 15)
		{
			csntc(nick, "Le pass doit faire entre 6 et 15 caractres.");
			return;
		}
		strncpy(p,parv[3],15);
#ifndef ADMINREG
	}
	else
	{
		srand(time(NULL)); /* on genere un mot de passe au pif */
		for(j=0;j<=10;j++)
		{
			do i = rand()%57 + 65;
			while(i >= 91 && i <= 96);
			c = i;
			p[j] = c;
		}
		p[11] = '\0';

	}
#endif

	if(!IsValidNick(parv[1]))
	{
		csntc(nick, "%s ne peut pas tre enregistr: contient des caractres illgaux", parv[1]);
		return;
	}
	if(IsBadNick(parv[1]))
	{
		csntc(nick, "%s ne peut pas tre enregistr: pseudo illgal.", parv[1]);
		return;
	}
	if ((user = getuserinfo(parv[1])))
	{
		duration(current - user->lastseend, dur);
		csntc(nick, "%s est dj un UserName enregistr. (Dernire visite il y a %s)", user->nick, dur);
		return;
	}
#ifndef ADMINREG
	if(nick->user)
	{
		csntc(nick, "Vous tes dj identifi sous l'username \002%s\002, et vous ne pouvez avoir plus d'un username.", nick->user);
		return;
	}
#endif
	if(strlen(parv[2]) > 140)
	{
		csntc(nick, "Le mail est limit  140 charactres.");
		return;
	}
	if(!IsValidMail(parv[2]))
	{
		csntc(nick, "Veuillez entrer un email correct.");
		return;
	}
	strcpy(passwd, mkpass(p, "lala"));

	for(user=userhead;user;user=user->next)
	{
		if(!strcasecmp(user->mail, parv[2]))
		{
			csntc(nick, "Ce mail est dj utilis.");
			return;
		}
	}

	flag |= U_POKACCESS;

#ifdef ADMINREG
	user = add_regnick(parv[1], passwd, current, 1, flag, 0, parv[2], 0);
#else
	if(!strcasecmp(mailprog, "nomail")) user = add_regnick(parv[1], passwd, current, 1, flag, 0, parv[2], 0); /* Pas de programme de mail, protection inactive */
    else
    {
		flag |= U_FIRST;
		user = add_regnick(parv[1], passwd, current, 1, flag, 0, parv[2], 0);
	}
#endif

#ifdef USE_MEMOSERV
	snprintf(memo, MEMOLEN, "Bienvenue sur les services CoderZ.  Vous pouvez avoir la liste de leur commandes en tapant \037/%s showcommands\037", cs.nick);
	add_memo(user, "Services", current, memo);
#endif

#ifndef ADMINREG
	if(NRegister(nick))
	{
		csntc(nick, "Vous avez dja utilis la commande register !");
		return;
	}
	SetNRegister(nick);
	if(!strcasecmp(mailprog, "nomail"))
	{
		nick->user = user;
		nick->user->n = nick;
		nick->user->vote = -1;
		nick->user->lastseend = current;
		cs_account(nick, nick->user->nick);

		csntc(nick, "Vous avez enregistr votre nick (%s) avec le pass \002%s\002 et le mail \002%s\002.",parv[1], parv[3], parv[2]);
		csntc(nick, "Votre nick devient votre UserName et sera utilis pour tous vos accs aux services.");
		csntc(nick, "\2Vous avez t identifi  TOUS les services");
		csntc(nick, "Lors de vos prochaines connexions vous pourrez vous identifier avec : \37/%s LOGIN %s %s", cs.nick, parv[1], parv[3]);
		csntc(nick, "Le mail (%s) que vous avez fournis peut etre utilis pour vous envoyer un pass en cas de problmes.", parv[2]);
		csntc(nick, "Vous pouvez avoir la liste des commandes avec \2/%s showcommands\2", cs.nick);
	}
	else
	{
		snprintf(dir, 50, "database/%s.mail", user->nick);
		if(!(fm = fopen(dir, "w")))
		{
			csntc(nick, "Impossible d'envoyer le mail");
			return;
		}
		fprintf(fm, "Subject: %s @ %s - Enregistrement pseudo %s", cs.nick, network, user->nick);
		fprintf(fm, "\n\n");
		fprintf(fm, "Ceci est un email automatique du robot %s\n", cs.nick);
		fprintf(fm, "\nVotre mot de passe est : %s\n", p);
		fprintf(fm, "\nVeuillez le conserver.\nPour vous identifier tapez : /%s login %s %s\n", cs.nick, user->nick, p);
		fprintf(fm, "Si vous voulez le changer, tapez: /%s set pass <pass>\n", cs.nick);
		fprintf(fm, "\n\n%s, Services IRC CoderZ de %s\n", cs.nick, network);
		fclose(fm);
		snprintf(mail, 150, "%s -f \"Services de %s\" %s < %s\n", mailprog, network, user->mail, dir);
		system(mail);
		remove(dir);

		duration(REGISTER_TIMEOUT, dur);
		csntc(nick, "Votre mot de passe a t envoy  \2%s\2", user->mail);
		csntc(nick, "Le compte sera supprim dans %s si vous ne vous logguez pas dessus", dur);

	}
#else
	csntc(nick, "Username \2%s\2 enregistr (Mail: %s Pass: %s)", user->nick, user->mail, parv[3]);
#endif
	append_file(USERS_FILE,user->nick);
	write_anuser(user);
	return;
}


/*
 * oubli_pass
 *
 * parv[1] = login
 * parv[2] = mail
 */
void oubli_pass(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	FILE *fm;
	anUser *user;
	char passwd[15], mail[150], dir[50];

	if(!strcasecmp(mailprog, "nomail"))
	{
		csntc(nick, "La commande est pour le moment desactive.");
		csntc(nick, "Si vous avez oubli votre pass, demandez  un admin (\002/%s admin\002) de le changer", cs.nick);
		return;
	}
	if(nick->user)
	{
		csntc(nick, "Vous tes dj identifi sur un username");
		return;
	}
	if(!(user = getuserinfo(parv[1])))
	{
		csntc(nick, "\002L'username %s existe pas !\002", parv[1]);
		return;
	}
	if(user->flag & U_OUBLI)
	{
		csntc(nick, "La commande OUBLI a dj t utilis pour %s.", user->nick);
		return;
	}
	if(strcasecmp(user->mail, parv[2]))
	{
		csntc(nick, "Le mail de l'account %s n'est pas %s", user->nick, parv[2]);
		return;
	}
	SetNRegister(nick); /* si il se sert de oubli, c'est qu'il a deja un pseudo ! na ! */
	user->flag |= U_OUBLI;

	if(user->nick[0] % 2) snprintf(passwd, 15, "np%02dl", rand());
	else snprintf(passwd, 15, "pr%02dh", rand());
	strcpy(user->passwd, mkpass(passwd, "lala"));

	snprintf(dir, 50, "database/%s.mail", user->nick);
	if(!(fm = fopen(dir, "w")))
	{
		csntc(nick, "Impossible d'envoyer le mail");
		return;
	}
	fprintf(fm, "Subject: %s @ %s - Mot de passe oubli", cs.nick, network);
	fprintf(fm, "\n\n");
	fprintf(fm, "Cher(e) %s\n", user->nick);
	fprintf(fm, "\nVotre mot de passe sur %s est maintenant : %s\n", cs.nick, passwd);
	fprintf(fm, "\nVeuillez le conserver.\nPour vous identifier tapez : /%s login %s %s\n", cs.nick, user->nick, passwd);
	fprintf(fm, "Si vous voulez le changer, tapez: /%s set pass <pass>\n", cs.nick);
	fprintf(fm, "\n\n%s, Services IRC CoderZ de %s\n", cs.nick, network);
	fclose(fm);
	snprintf(mail, 150, "%s -f \"Services d'%s\" %s < %s\n", mailprog, network, user->mail, dir);
	system(mail);
	remove(dir);

	csntc(nick, "Le nouveau pass vient d'tre envoy par mail  %s", parv[2]);
	write_anuser(user);
	return;
}


void drop_user(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anAccess *access, *a2;
	char p[15];

	if(!nick->user)
	{
		csntc(nick, "Accs refus. Vous devez tre identifi pour DROP votre Username.");
		return;
	}

	if(UWantDrop(nick->user))
	{
		if(!strcasecmp(parv[1], "OUI"))
		{
			csntc(nick, "Votre UserName (%s) a t supprim, ainsi que tous vos accs/mmos.", nick->user->nick);
			cs_account(nick, NULL);

			for(access=nick->user->accesshead;access;access=a2)
			{
				a2=access->next;
				if(access->level == 500)
				{
					del_chan(access->chan);
					csntc(nick, "Le salon %s a bien t dsenregistr", access->chan);
					cspart(access->chan, "Salon dsenregistr par %s -\002 Suppression de l'username de l'owner", nick->nick);
					cswallops("Le salon %s a t dsenregistr par %s -\002 Suppression de l'username de l'owner", access->chan, nick->nick);
					putlog(LOG_CHANS, "DROP %s par %s@%s (%s)\n", access->chan, nick->nick, nick->user->nick, "Suppression de l'username de l'owner");
					break;
				}
			}
			del_regnick(nick->user);
			write_userlist();
			nick->user = NULL;
		}
		else if(!strcasecmp(parv[1], "NON"))
		{
			csntc(nick, "Votre username ne sera donc pas supprim");
			DelUWantDrop(nick->user);
		}
		else
		{
			csntc(nick, "Voulez vous rellement supprimer votre username ?");
			csntc(nick, "Rponse : /z drop oui/non");
		}
		return;
	}
	else
	{
		strncpy(p,parv[1],15);
		if (!strcmp(mkpass(p, "lala"), nick->user->passwd))
		{
			csntc(nick, "Voulez vous rellement supprimer votre username ?");
			csntc(nick, "\002ATTENTION :\002 La suppression de votre username se rsulte  supprimer tous vos memos, vos access et votre salon. Vous ne pouvez \002PAS\002 revenir en arrire ");
			csntc(nick, "Rponse : /z drop oui/non");
			SetUWantDrop(nick->user);
		}
		else
			csntc(nick, "\002Mot de passe invalide !");
	}
	DelNRegister(nick);
	return;
}

void ns_login(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anUser *user = NULL;
	aJoin *j=NULL;
#ifdef USE_MEMOSERV
	struct memos *memo;
#endif
#ifdef HAVE_VOTE
	extern const int vote_nbprop, vote_actif;
#endif
#ifdef HAVE_TRACK
	struct track *track;
#endif
	anAccess *a;
	char p[15], dur[230];
	int i = 0, needop, needvoice;
	time_t current = time(NULL);

	if(!(user = getuserinfo(parv[1])))
	{
		csntc(nick, NOSUCHUSER, parv[1]);
		return;
	}

	if(nick->user)
	{
		csntc(nick, "Vous tes dj identifi sous l'username \002%s\002.", nick->user->nick);
		if(IsAnAdmin(user) && user->nick != nick->user->nick)
		{
			cswall("Failed Login sur \002%s\002 par \002%s\002 (\002Admin %d\002)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d MAIL %s par %s@%s\n", user->nick, user->level, user->mail, nick->nick, nick->user->nick);
		}
		return;
	}

	if(user->n)
	{
		csntc(nick, "Quelqu'un est dj identifi sur cet username");
		if(IsAnAdmin(user))
		{
			cswall("Failed Login sur \002%s\002 par \002%s\002 (\002Admin %d\002)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d MAIL %s par %s\n", user->nick, user->level, user->mail, nick->nick);
		}
		return;
	}

	if(user->suspendu > 0)
	{
		duration(current - user->suspendu, dur);
		csntc(nick, "Votre Username est suspendu (depuis %s), soit par scurit, soit par les Admins, consultez votre e-mail pour connaitre votre nouveau pass", dur);
		if(IsAnAdmin(user))
		{
			cswall("Failed Login sur \002%s\002 par \002%s\002 (\002Admin %d\002)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d MAIL %s par %s\n", user->nick, user->level, user->mail, nick->nick);
		}
		return;
	}

	strncpy(p,parv[2],15);
	if (strcmp(mkpass(p, "lala"), user->passwd))
	{
		csntc(nick, "\002Mot de pass incorrect !\002");
		csntc(nick, "Si vous ne vous en rappelez plus, utilisez : \002 /%s oubli %s <mail>\002", cs.nick, user->nick);
		if(IsAnAdmin(user))
		{
			cswall("Failed Login sur \002%s\002 par \002%s\002 (\002Admin %d\002)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d MAIL %s par %s\n", user->nick, user->level, user->mail, nick->nick);
		}
		return;
	}

#ifdef HAVE_TRACK
	if((track=istrack(user))) csntc(track->tracker, "[\2Track\2] Login de %s (%s!%s@%s)", user->nick, nick->nick, nick->ident, nick->host);
#endif

	if(UOubli(user)) DelUOubli(user);
	if(UFirst(user)) DelUFirst(user);
	SetNRegister(nick);
	nick->user = user;
	nick->user->n = nick;
	nick->user->lastseend = current;
	del_killinfo(nick->nick, nick->numeric); /* arret du kill, vu ke c son nick !*/
	cs_account(nick, nick->user->nick);

	csntc(nick, "Login \002russi\002 pour %s, vous avez dsormais accs  tous vos salons, mmos et au contrle de votre pseudo", nick->user);

	if(IsAnAdmin(nick->user))
	{
		csntc(nick, "\002Vous tes identifi en tant qu'Administrateur niveau %d", nick->user->level);
		if(admin_motd[0]!='\0') csntc(nick, "Message du jour Admin :\2 %s", admin_motd);
		if(!HasMode(nick, 'w')) putserv("%s %s %s :+w\n", cs.num, TOKEN_SVSMODE, nick->numeric);
	}
	else if(user_motd[0]!='\0') csntc(nick, "Message du jour User :\2 %s", user_motd);

#ifdef HAVE_CRYPTHOST
	if((ConfFlag & CF_HOSTHIDING) && (ConfFlag & CF_XMODE) && UWantX(user) && !HasMode(nick, 'x')) putserv("%s %s %s :+x\n", cs.num, TOKEN_SVSMODE, nick->numeric);
#endif

#ifdef USE_MEMOSERV
	for(memo=nick->user->memohead;memo;memo=memo->next) i++;

	if(i) csntc(nick, "Vous avez reu \002%d\002 memo%s, pour le%s lire tapez \2/%s memos LIRE <ALL|N du memo>\2", i, (i>1)?"s":"", (i>1)?"s":"", cs.nick);
#endif

#ifdef HAVE_VOTE
	if(vote_actif && vote_nbprop && !user->vote)
	{
			show_vote(nick);
			csntc(nick, "Pour voter tapez \2\37/%s voter <n de la proposition>\2\37.", cs.nick);
	}
#endif

	/*auto-autoop propos par BugMaster :)*/
	for(a=nick->user->accesshead;a;a=a->next)
	{
		if((j=getjoininfo(nick,a->c->chan))) a->lastseen = current;

		if(j && (AOp(a) || AVoice(a)) && !ASuspend(a) && a->level >= 50)
		{
			needop = 0;
			needvoice = 0;
			if(AOp(a) && !j->is_op && a->level >= 100 && !CNoOps(a->c)) j->is_op = needop = 1;
			if(AVoice(a) && !j->is_voice) j->is_voice = needvoice = 1;
			if(needop || needvoice) csmode(a->c, "+%s%s %s %s", needop ? "o" : "", needvoice ? "v" : "", needop ? nick->numeric : "", needvoice ? nick->numeric : "");
		}
		if(a->c->motd[0]!='\0')	csntc(nick, "\002 [Message du jour] - %s -\002 %s", a->c->chan, a->c->motd);
		if(CAutoInvite(a->c) && strchr(a->c->modes, 'i')) putserv("%s %s %s :%s\n", cs.num, TOKEN_INVITE, nick->nick, a->c->chan);
	}

	write_anuser(user); /* **joli** oubli qui a cout le deluser a beaucoup.. */
	return;
}

void recover(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anUser *user;
	anAccess *a;
	aJoin *j;
	time_t current = time(NULL);
#ifdef USE_MEMOSERV
	aMemo *memo;
#endif
#ifdef HAVE_VOTE
	extern const int vote_nbprop, vote_actif;
#endif
#ifdef HAVE_TRACK
	struct track *track;
#endif
	aNick *who, *w;
	char p[15], buff[NICKLEN], dur[230];
	int i=0, needop, needvoice;

	if(!(user = getuserinfo(parv[1])))
	{
		csntc(nick, NOSUCHUSER, parv[1]);
		return;
	}
	if(nick->user)
	{
		if(!strcasecmp(nick->user->nick, user->nick))
			csntc(nick, "Vous tes dj identifi sur ce pseudo !");
		else
		{
			csntc(nick, "Vous tes dj identifi sous l'username \002%s\002, et vous ne pouvez avoir plus d'un username.", nick->user->nick);
			if(IsAnAdmin(user) && user->nick != nick->user->nick)
				putlog(LOG_FAUTH, "RECOVER %s NIVEAU %d MAIL %s par %s\n", user->nick, user->level, user->mail, nick->nick);
		}

		return;
	}

	if(user->suspendu > 0)
	{
		duration(current - user->suspendu, dur);
		csntc(nick, "Votre Username est suspendu (depuis %s), soit par scurit, soit par les Admins, consultez votre e-mail pour connaitre votre nouveau pass", dur);
		if(IsAnAdmin(user))
		{
			cswall("Failed Login sur \002%s\002 par \002%s\002 (\002Admin %d\002)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d MAIL %s par %s\n", user->nick, user->level, user->mail, nick->nick);
		}
		return;
	}

	strncpy(p,parv[2],15);
	if (strcmp(mkpass(p, "lala"), user->passwd))
	{
		csntc(nick, "\002Mot de pass incorrect !\002");
		csntc(nick, "Si vous ne vous en rappelez plus, utilisez : \002 /%s oubli %s <mail>\002", cs.nick, user->nick);
		if(user->level > 1)
			putlog(LOG_FAUTH, "RECOVER %s NIVEAU %d MAIL %s par %s\n", user->nick, user->level, user->mail, nick->nick);
		return;
	}
	who = nickhead;
	while(who)
	{
		w = who->next;
		if(strcmp(nick->nick, who->nick) && !strcmp(who->nick, user->nick))
		/* on a trouv un vilain avec le pseudo */
		{
			if(who->user && !strcmp(who->user->nick, user->nick)) /* Le vilain est loggu sur le compte a recover */
			{
				cs_account(who, NULL);
				csntc(who, "%s a utilis recover: \002vous n'tes plus identifi", nick->nick);
				who->user->n = NULL;
				who->user = NULL;
			}
			if(!UKill(user)) /* on svsnick */
			{
				snprintf(buff, NICKLEN, "%s%02d", CHNICKRAND, rand());
				putserv("%s %s %s :%s\n", bot.servnum, TOKEN_SVSNICK, who->numeric, buff);
			}
			else /* ou bien on kill */
			{
				putserv("%s %s %s :%s (Pseudo enregistr)\n", cs.num, TOKEN_KILL, who->numeric, cs.nick);
				del_nickinfo(who);
			}
			break; /* on termine la boucle, pas possible d'avoir 2 vilains avec le meme pseudo */
		}
		who = w;
	}
	if(!strcasecmp(user->nick, nick->nick) && UProtect(user)) del_killinfo(nick->nick, nick->numeric);
	if(UOubli(user)) DelUOubli(user);
	if(UFirst(user)) DelUFirst(user);
	SetNRegister(nick);

#ifdef HAVE_TRACK
	if((track=istrack(user))) csntc(track->tracker, "[\2Track\2] Recover de %s (%s!%s@%s)", user->nick, nick->nick, nick->ident, nick->host);
#endif

	nick->user = user;
	nick->user->n = nick;
	nick->user->lastseend = current;
	cs_account(nick, nick->user->nick);

#ifdef HAVE_CRYPTHOST
	if((ConfFlag & CF_HOSTHIDING) && (ConfFlag & CF_XMODE) && UWantX(user) && !HasMode(nick, 'x')) putserv("%s %s %s :+x\n", cs.num, TOKEN_SVSMODE, nick->numeric);
#endif

	csntc(nick, "Login \002russi\002 pour %s, vous avez dsormais accs  tous vos salons, mmos et au contrle de votre pseudo", nick->user->nick);
	if(IsAnAdmin(nick->user))
	{
		csntc(nick, "\002Vous tes identifi en tant qu'admin niveau %d", nick->user->level);
		if(admin_motd[0]!='\0') csntc(nick, "Message du jour Admin :\2 %s", admin_motd);
		if(!HasMode(nick, 'w')) putserv("%s %s %s :+w\n", cs.num, TOKEN_SVSMODE, nick->numeric);
	}
	else if(user_motd[0]!='\0') csntc(nick, "Message du jour User :\2 %s", user_motd);

#ifdef USE_MEMOSERV
	for(memo = nick->user->memohead;memo;memo=memo->next) i++;
	if(i)
	{
		csntc(nick, "Vous avez reu \002%d\002 memos", i);
		csntc(nick, "Pour les lire tapez \002/%s memos LIRE <ALL|N du memo>\002", cs.nick);
	}
#endif

#ifdef HAVE_VOTE
	if(vote_actif && vote_nbprop && !user->vote)
	{
			show_vote(nick);
			csntc(nick, "Pour voter tapez \2\37/%s voter <n de la proposition>\2\37.", cs.nick);
	}
#endif

	/*auto-autoop propos par BugMaster :)*/
	for(a=nick->user->accesshead;a;a=a->next)
	{
		if((j=getjoininfo(nick,a->c->chan))) a->lastseen = current;

		if(j && (AOp(a) || AVoice(a)) && !ASuspend(a) && a->level >= 50)
		{
			needop = 0;
			needvoice = 0;
			if(AOp(a) && !j->is_op && a->level >= 100 && !CNoOps(a->c)) j->is_op = needop = 1;
			if(AVoice(a) && !j->is_voice) j->is_voice = needvoice = 1;
			if(needop || needvoice) csmode(a->c, "+%s%s %s %s", needop ? "o" : "", needvoice ? "v" : "", needop ? nick->numeric : "", needvoice ? nick->numeric : "");
		}
		if(a->c->motd[0]!='\0')
			csntc(nick, "\002 [Message du jour] - %s -\002 %s", a->c->chan, a->c->motd);
		if(CAutoInvite(a->c) && strchr(a->c->modes, 'i')) putserv("%s %s %s :%s\n", cs.num, TOKEN_INVITE, nick->nick, a->c->chan);
	}

	write_anuser(user);
	return;
}

void myaccess(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char chans[1000], b[215];
	int access=0, chan=0, i=0;
#ifdef HAVE_VOTE
	extern const struct votes vote[];
	extern const int vote_actif;
#endif
	anAccess *a;
	aWaitAccess *wa;

	if(!nick->user) return;
	access=getoption("-access",parv,parc,1,-1);
	if(!access)
	{
		a = nick->user->accesshead;
		b[0] = '\0';
		chans[0] = '\0';
		while(a)
		{
			snprintf(b, 215, "%s (%d) ", a->chan, a->level);
			strncat(chans, b, 215);
			a = a->next;
		}
		csntc(nick, "Info sur l'Username \002%s", nick->user->nick);
		csntc(nick, " Mail enregistr: %s", nick->user->mail);
		if(IsAnAdmin(nick->user)) csntc(nick, "\002Accs Administrateur\002 (\002%d\002)", nick->user->level);
		if(chans[0] != '\0') csntc(nick, "Vous avez accs : %s", chans);

		chans[0]='\0';
		for(wa=nick->user->wahead;wa;wa=wa->next)
		{
			snprintf(b, 215, "%s (%d) ", wa->chan, wa->level);
			strncat(chans, b, 215);
		}
		if(chans[0] != '\0' && (nick->user->flag & U_POKACCESS)) csntc(nick, " Vous avez des propositions d'access pour: %s", chans);
		else if((nick->user->flag & U_POKACCESS)) csntc(nick, " Vous n'avez aucune proposition d'access");
		else csntc(nick, " Vous %s les propositions d'accs", (nick->user->flag & U_PACCEPT) ? "acceptez" : "refusez");
		csntc(nick, " Le VIRTUALHOST est %sactif", UWantX(nick->user) ? "" : "in");

#ifdef HAVE_VOTE
		if(vote_actif)
		{
			if(nick->user->vote) csntc(nick, " Vous avez vot pour: \2%s", vote[(nick->user->vote-1)].prop);
			else csntc(nick, " Vous n'avez pas encore vot");
		}
#endif
		if(UNopurge(nick->user)) csntc(nick, " Vous avez le NOPURGE actif");
		if(UProtect(nick->user)) csntc(nick, "La protection est active. %s", UKill(nick->user) ? "(KILL)" : "(Changenick)");
		else csntc(nick, "La protection est desactive", kill_interval);
		return;
	}
	chan=getoption("-chan",parv,parc,1,0);
	for(a=nick->user->accesshead;a;a=a->next)
	{
		if(chan && match(parv[chan], a->chan)) continue;
		csntc(nick, "%s", a->chan);
		show_accessn(a, nick->user, nick);
		csntc(nick, "-");
		i++;
	}
	csntc(nick, "Un Total de %d entre%s trouve%s", i, i > 1 ? "s" : "", i > 1 ? "s": "");
	return;
}

void deauth(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
   if(!nick->user)
   {
      csntc(nick, "Vous n'tes pas loggu");
	  return;
   }
   csntc(nick, "Vous venez de vous dlogguer du compte \002%s\002", nick->user->nick);
   cs_account(nick, NULL);
   nick->user->n = 0;
   nick->user = NULL;
   return;
}

void user_set(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	const char *arg=parv[1];

	if(!strcasecmp(arg,"mail"))
	{
		anUser *users;
		if(parc < 2)
		{
			csntc(nick, "Syntaxe: SET MAIL <mail>");
			return;
		}
		if(strlen(parv[2]) > 148)
		{
			csntc(nick, "Le mail est limit  148 charactres.");
			return;
		}
		if(!IsValidMail(parv[2]))
		{
			csntc(nick, "Veuillez entrer un email correct.");
			return;
		}
		if(!strcasecmp(nick->user->mail, parv[2]))
		{
			csntc(nick, "%s est dj votre mail enregistr.", parv[2]);
			return;
		}

		for(users=userhead;users && strcasecmp(users->mail, parv[2]);users = users->next);
		if(users)
		{
			csntc(nick, "Ce mail est dj utilis.");
			return;
		}

		strcpy(nick->user->mail, parv[2]);
		csntc(nick, "Votre mail a t chang en \002%s", nick->user->mail);
	}
	else if(!strcasecmp(arg, "virtualhost"))
	{
		if(!(ConfFlag & CF_XMODE))
		{
			csntc(nick, "La commande VIRTUALHOST est desactive");
			return;
		}
		if(parc < 2) nick->user->flag = ToggleFlag(nick->user->flag, U_WANTX);
		else if(!strcasecmp(parv[2], "ON")) SetUWantX(nick->user);
		else if(!strcasecmp(parv[2], "OFF")) DelUWantX(nick->user);
		else
		{
			csntc(nick, "La valeur doit tre ON ou OFF");
			return;
		}

		if(UWantX(nick->user)) csntc(nick, "L'option VIRTUALHOST est ACTIVE: Lors de votre identification, votre host sera automatiquement change en %s.%s", nick->user->nick, HIDDEN_HOST);
		else csntc(nick, "L'option VIRTUALHOST est DESACTIV.");
	}
	else if(!strcasecmp(arg, "kill"))
	{
		if(parc < 2) nick->user->flag = ToggleFlag(nick->user->flag, U_KILL);
		else if(!strcasecmp(parv[2], "ON")) SetUKill(nick->user);
		else if(!strcasecmp(parv[2], "OFF")) DelUKill(nick->user);
		else
		{
			csntc(nick, "La valeur doit tre ON ou OFF");
			return;
		}

		if(UKill(nick->user)) csntc(nick, "Si PROTECT est ON, lorsqu'un user prendra comme pseudo votre username, il se fera kill au bout de %d secondes", kill_interval);
		else csntc(nick, "Si PROTECT est ON, lorsqu'un user prendra comme pseudo votre username, il se fera changer son pseudo au bout de %d secondes", kill_interval);
	}
	else if(!strcasecmp(arg, "protect"))
	{
		if(parc < 2) nick->user->flag = ToggleFlag(nick->user->flag, U_PROTECT);
		else if(!strcasecmp(parv[2], "ON")) SetUProtect(nick->user);
		else if(!strcasecmp(parv[2], "OFF")) DelUProtect(nick->user);
		else
		{
			csntc(nick, "La valeur doit tre ON ou OFF");
			return;
		}

		if(UProtect(nick->user))
		{
			if(UKill(nick->user)) csntc(nick, "La protection est active. Lorsqu'un user prendra comme pseudo votre username, il se fera kill au bout de %d secondes", kill_interval);
			else csntc(nick, "La protection est active. Lorsqu'un user prendra comme pseudo votre username, il se fera chang de pseudo au bout de %d secondes", kill_interval);
		}
		else csntc(nick, "La protection est desactive", kill_interval);
	}
	else if(!strcasecmp(arg, "nomemo"))
	{
		if(parc < 2) nick->user->flag = ToggleFlag(nick->user->flag, U_NOMEMO);
		else if(!strcasecmp(parv[2], "ON")) SetUNoMemo(nick->user);
		else if(!strcasecmp(parv[2], "OFF")) DelUNoMemo(nick->user);
		else
		{
			csntc(nick, "La valeur doit tre ON ou OFF");
			return;
		}

		if(UNoMemo(nick->user))
			csntc(nick, "Le NOMEMO est actif: personne ne pourra vous envoyer de memos (except les admins)");
		else csntc(nick, "Le NOMEMO est inactif: tous le monde peut vous envoyer des memos");
	}
	else if(!strcasecmp(arg,"pass"))
	{
		char p[15];

		if(parc < 2)
		{
			csntc(nick, "Syntaxe: SET PASS <pass>");
			return;
		}
		strncpy(p,parv[2],15);
		if(strlen(p) < 6)
		{
			csntc(nick, "Le pass doit faire entre 6 et 15 caractres.");
			return;
		}

		strcpy(nick->user->passwd, mkpass(p, "lala"));
		csntc(nick, "\002Votre pass a bien t chang\002");
	}
	else if(!strcasecmp(arg, "username"))
	{
		anUser *u;
		char old[60], sh[200], new[60];

		if(parc < 2)
		{
			csntc(nick, "Syntaxe: SET USERNAME <nouvel username>");
			return;
		}

		if(strlen(parv[2]) >= NICKLEN)
		{
			csntc(nick, "La longueur des UserNames est limite  %d.", NICKLEN);
			return;
		}

		if(!IsValidNick(parv[2]))
		{
			csntc(nick, "%s ne peut pas tre enregistr: contient des caractres illgaux", parv[2]);
			return;
		}
		if(IsBadNick(parv[2]))
		{
			csntc(nick, "%s ne peut pas tre enregistr: pseudo illgal.", parv[2]);
			return;
		}
		if((u=getuserinfo(parv[2])))
		{
			csntc(nick, "\002%s\002 est dj enregistr.", u->nick);
			return;
		}

		strcpy(old, "");
		strcpy(new, "");
		conv_char(nick->user->nick, old);
		cs_account(nick, parv[2]);
		strncpy(nick->user->nick, parv[2], NICKLEN);
		csntc(nick, "Votre username a t chang en %s", parv[2]);
		conv_char(nick->user->nick, new);
		snprintf(sh, 200, "mv database/usr/%s database/usr/%s", old, new);
		strlwr(sh);
		system(sh);
		write_userlist();
	}
	else if(!strcasecmp(arg, "access"))
	{
		int i;
		aWaitAccess *wa;

		if(parc < 2)
		{
			csntc(nick, "Syntaxe: SET ACCESS <0/1/2>");
			csntc(nick, "Syntaxe: 0 Refuse toute proposition d'accs");
			csntc(nick, "Syntaxe: 1 Utilisation de okaccess");
			csntc(nick, "Syntaxe: 2 Accepte toute proposition d'accs");
			return;
		}
		i = atoi(parv[2]);
		if(i < 0 || i > 2)
		{
			csntc(nick, "L'argument doit tre compris entre 0 et 2.");
			return;
		}
		switch(i)
		{
			case 0:
			nick->user->flag &= ~(U_POKACCESS | U_PACCEPT);
			nick->user->flag |= U_PREJECT;
			break;
			case 1:
			nick->user->flag &= ~(U_PACCEPT | U_PREJECT);
			nick->user->flag |= U_POKACCESS;
			break;
			case 2:
			nick->user->flag &= ~(U_PREJECT | U_POKACCESS);
			nick->user->flag |= U_PACCEPT;
			break;
		}
		if(!i)
		{
			csntc(nick, "Les propositions d'accs vous concernant seront systmatiquement refuses.");
			for(wa = nick->user->wahead;wa;wa = wa->next) del_waitaccess(nick->user->nick, wa->chan);
			csntc(nick, "Vos propositions en cours on t supprimes.");
		}
		else if(i == 2)
		{
			int flag;
			csntc(nick, "Les propositions d'accs vous concernant seront systmatiquement acceptes.");
			for(wa = nick->user->wahead;wa;wa = wa->next)
			{
				flag=0;
				if(wa->level >= 400) flag |= (A_OP | A_PROTECT);
				add_access(nick->user, wa->chan, wa->level, flag, "", time(NULL));
				del_waitaccess(nick->user->nick, wa->chan);
			}
			csntc(nick, "Vos propositions en cours on t acceptes.");
		}
		else csntc(nick, "Vous utilisez  prsent okaccess.");
	}
	else
	{
		csntc(nick, "Option de SET inconnue.");
		return;
	}
	write_anuser(nick->user);
	return;
}
