/* src/opdeop.c - Fonctions de base chanserv (op, deop, voice, devoice, etc)
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <main.h>
#include <time.h>

CVSINFO("$Id: opdeop.c,v 1.3 2003/02/14 18:12:40 romexzf Exp $");

void op(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
  int i, count = 0, nbnoco = 0;
  char buff[100], mode[7], *c, noco[400];
  struct nickinfo *n;
  struct joininfo *chan;
  buff[0] = '\0';
  mode[0] = '\0';
  c = parv[1];

  if(CNoOps(chaninfo))
  {
	  csntc(nick, "Le NOOPS est actif sur %s", c);
	  return;
  }
  if(parc == 1)
  {
	  if(!(chan=getjoininfo(nick,c)))
	  {
		  csntc(nick, "Vous n'tes pas sur %s", c);
		  return;
	  }
	  chan->is_op = 1;
	  csmode(chaninfo, "+o %s", nick->numeric);
	  return;
  }
  noco[0]='\0';
  for(i=2;i<=parc;i++)
  {
	  if(!strcasecmp(parv[i], cs.nick)) continue;
	  if(!(n = getnickbynick(parv[i])))
	  {
	  	  if(strlen(noco) >= (400-NICKLEN)) continue;
	  	  if(noco[0]!='\0') strcat(noco, " ");
		  strcat(noco, parv[i]);
		  nbnoco++;
		  continue;
	  }
	  if(!(chan=getjoininfo(n,c)))
	  {
		  csntc(nick, "%s n'est pas sur %s", n->nick, c);
		  continue;
	  }
	  if(chan->is_op) continue;
	  chan->is_op = 1;

	  count++;
	  strcat(mode, "o");
	  sprintf(buff, "%s %s", buff, n->numeric);
	  if(count > 5)
	  {
		  csmode(chaninfo, "+%s %s", mode, buff);
		  count = 0;
		  buff[0] = '\0';
		  mode[0] = '\0';
	  }
  }
  if(nbnoco == 1) csntc(nick, NOTCONNECTED, noco);
  else if(nbnoco) csntc(nick, "%s ne sont pas connects", noco);

  if(count) csmode(chaninfo, "+%s %s", mode, buff);
  return;
}

void deop(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
  int i, count = 0, nbnoco = 0;
  char buff[100], mode[7], *c, noco[400];
  struct nickinfo *n;
  struct joininfo *chan;

  buff[0] = '\0';
  mode[0] = '\0';
  c = parv[1];

  if(parc == 1)
  {
	  if(!(chan=getjoininfo(nick,c)))
	  {
		  csntc(nick, "Vous n'tes pas sur %s", c);
		  return;
	  }
	  chan->is_op = 0;
	  csmode(chaninfo, "-o %s", nick->numeric);
	  return;
  }
  noco[0]='\0';
  for(i=2;i<=parc;i++)
  {
	  if(!strcasecmp(parv[i], cs.nick))
	  {
		  csntc(nick, "Merci de ne pas Deop %s", cs.nick);
		  continue;
	  }

	  if(!(n = getnickbynick(parv[i])))
	  {
	  	  if(strlen(noco) >= (400-NICKLEN)) continue;
	  	  if(noco[0]!='\0') strcat(noco, " ");
		  strcat(noco, parv[i]);
		  nbnoco++;
		  continue;
	  }
	  if(HasMode(n, 'p') && !HasMode(nick, 'o'))
	  {
		  csntc(nick, "%s est IRCop.", n->nick);
		  continue;
	  }
	  if(n->user && IsAnAdmin(n->user) && n->user->level > nick->user->level)
	  {
		  csntc(nick, "%s est Administrateur des Services.", n->nick);
		  continue;
	  }

	  if(!(chan=getjoininfo(n,c)))
	  {
		  csntc(nick, "%s n'est pas sur %s", n->nick, c);
		  continue;
	  }
	  chan->is_op = 0;
	  count++;
	  strcat(mode, "o");
	  sprintf(buff, "%s %s", buff, n->numeric);
	  if(count > 5)
	  {
		  csmode(chaninfo, "-%s %s", mode, buff);
		  count = 0;
		  buff[0] = '\0';
		  mode[0] = '\0';
	  }
  }
  if(nbnoco == 1) csntc(nick, NOTCONNECTED, noco);
  else if(nbnoco) csntc(nick, "%s ne sont pas connects", noco);
  if(count) csmode(chaninfo, "-%s %s", mode, buff);
  return;
}

void opall(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aLink *lp = NULL;
	char *c = parv[1], buf[60], m[7];
	int i = 0;

	buf[0] = '\0';
	m[0] = '\0';

	if(CNoOps(chaninfo))
	{
		csntc(nick, "Le NOOPS est actif sur %s", c);
		return;
	}

	for(lp=chaninfo->members;lp;lp=lp->next)
	{
		if(!lp->value.j->is_op)
		{
			strcat(m, "o");
			sprintf(buf, "%s %s", buf, lp->value.j->nick->numeric);
			lp->value.j->is_op = 1;
			i++;
			if(i > 5)
			{
				csmode(chaninfo, "+%s %s", m, buf);
				i = 0;
				buf[0] = '\0';
				m[0] = '\0';
			}
		}
	}
	if(i > 0 && buf[0] != '\0') csmode(chaninfo, "+%s %s", m, buf);
	return;
}

void deopall(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aLink *lp;
	aNick *n = NULL;
	char buf[150], m[7];
	int i = 0;

	buf[0] = '\0';
	m[0] = '\0';

	for(lp=chaninfo->members;lp;lp=lp->next)
	{
		if(lp->value.j->is_op && (n=lp->value.j->nick) && (!n->is_oper && (!n->user || !IsAnAdmin(n->user) || n->user->level <= nick->user->level)))
		{
			strcat(m, "o");
			sprintf(buf, "%s %s", buf, lp->value.j->nick->numeric);
			lp->value.j->is_op = 0;
			i++;
			if(i > 5)
			{
				csmode(chaninfo, "-%s %s", m, buf);
				i = 0;
				buf[0] = '\0';
				m[0] = '\0';
			}
		}
	}

	if(i) csmode(chaninfo, "-%s %s", m, buf);
	return;
}

void voice(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
  int i, count = 0, nbnoco = 0;
  char buff[100], mode[7], *c, noco[400];
  struct nickinfo *n;
  struct joininfo *chan;
  buff[0] = '\0';
  mode[0] = '\0';
  c = parv[1];

  if(parc == 1)
  {
	  if(!(chan=getjoininfo(nick,c)))
	  {
		  csntc(nick, "Vous n'tes pas sur %s", c);
		  return;
	  }
	  csmode(chaninfo, "+v %s", nick->numeric);
	  chan->is_voice = 1;
	  return;
  }
  noco[0]='\0';
  for(i=2;i<=parc;i++)
  {
	  if(!strcasecmp(parv[i], cs.nick)) continue;
	  n = getnickbynick(parv[i]);
	  if(!n)
	  {
	  	  if(strlen(noco) >= (400-NICKLEN)) continue;
	  	  if(noco[0]!='\0') strcat(noco, " ");
		  strcat(noco, parv[i]);
		  nbnoco++;
		  continue;
	  }
	  if(!(chan=getjoininfo(n,c)))
	  {
		  csntc(nick, "%s n'est pas sur %s", n->nick, c);
		  continue;
	  }
	  if(chan->is_voice) continue;
	  chan->is_voice = 1;

	  count++;
	  strcat(mode, "v");
	  sprintf(buff, "%s %s", buff, n->numeric);
	  if(count > 5)
	  {
		  csmode(chaninfo, "+%s %s", mode, buff);
		  count = 0;
		  buff[0] = '\0';
		  mode[0] = '\0';
	  }
  }
  if(nbnoco == 1) csntc(nick, NOTCONNECTED, noco);
  else if(nbnoco) csntc(nick, "%s ne sont pas connects", noco);
  if(count) csmode(chaninfo, "+%s %s", mode, buff);
  return;
}

void devoice(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
  int i, count = 0, nbnoco = 0;
  char buff[100], mode[7], *c, noco[400];
  struct nickinfo *n;
  struct joininfo *chan;

  buff[0] = '\0';
  mode[0] = '\0';
  c = parv[1];

  if(parc == 1)
  {
	  if(!(chan=getjoininfo(nick,c)))
	  {
		  csntc(nick, "Vous n'tes pas sur %s", c);
		  return;
	  }
	  csmode(chaninfo, "-v %s", nick->numeric);
	  chan->is_voice = 0;
	  return;
  }
  noco[0]='\0';
  for(i=2;i<=parc;i++)
  {
	  n = getnickbynick(parv[i]);
	  if(!n)
	  {
	  	  if(strlen(noco) >= (400-NICKLEN)) continue;
	  	  if(noco[0]!='\0') strcat(noco, " ");
		  strcat(noco, parv[i]);
		  nbnoco++;
		  continue;
	  }

	  if(!(chan=getjoininfo(n,c)))
	  {
		  csntc(nick, "%s n'est pas sur %s", n->nick, c);
		  continue;
	  }
	  if(!chan->is_voice) continue;
	  chan->is_voice = 0;
	  count++;
	  strcat(mode, "v");
	  sprintf(buff, "%s %s", buff, n->numeric);
	  if(count > 5)
	  {
		  csmode(chaninfo, "-%s %s", mode, buff);
		  count = 0;
		  buff[0] = '\0';
		  mode[0] = '\0';
	  }
  }
  if(nbnoco == 1) csntc(nick, NOTCONNECTED, noco);
  else if(nbnoco) csntc(nick, "%s ne sont pas connects", noco);
  if(count) csmode(chaninfo, "-%s %s", mode, buff);
  return;
}

void voiceall(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aLink *lp = NULL;
	char buf[60], m[7];
	int i = 0;

	buf[0] = '\0';
	m[0] = '\0';

	for(lp=chaninfo->members;lp;lp=lp->next)
	{
		if(!lp->value.j->is_voice)
		{
			strcat(m, "v");
			sprintf(buf, "%s %s", buf, lp->value.j->nick->numeric);
			lp->value.j->is_voice = 1;
			i++;
			if(i > 5)
			{
				csmode(chaninfo, "+%s %s", m, buf);
				i = 0;
				buf[0] = '\0';
				m[0] = '\0';
			}
		}
	}
	if(i > 0 && buf[0] != '\0') csmode(chaninfo, "+%s %s", m, buf);
	return;
}

void devoiceall(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aLink *lp = NULL;
	char buf[60], m[7];
	int i = 0;

	buf[0] = '\0';
	m[0] = '\0';

	for(lp=chaninfo->members;lp;lp=lp->next)
	{
		if(lp->value.j->is_voice)
		{
			strcat(m, "v");
			sprintf(buf, "%s %s", buf, lp->value.j->nick->numeric);
			lp->value.j->is_voice = 0;
			i++;
			if(i > 5)
			{
				csmode(chaninfo, "-%s %s", m, buf);
				i = 0;
				buf[0] = '\0';
				m[0] = '\0';
			}
		}
	}
	if(i > 0 && buf[0] != '\0') csmode(chaninfo, "-%s %s", m, buf);
	return;
}

void kickall(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aLink *lp;
	aNick *n = NULL;
	char r[180];

	if(parc < 2) strcpy(r, "Requested");
	else parv2msgn(parc,parv,2, r, 180);

	for(lp=chaninfo->members;lp;lp=lp->next)
	{
		if((n=lp->value.j->nick) && n != nick && (!n->is_oper && (!n->user || !IsAnAdmin(n->user) || n->user->level <= nick->user->level)))
			cskick(chaninfo->chan, n->numeric, "%s", r);
	}
	return;
}

void kickbanall(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aLink *lp;
	aNick *n = NULL;
	char r[180], *mask;

	if(parc < 2)
	{
		csntc(nick, "Veuillez prciser une raison.");
		return;
	}
	parv2msgn(parc,parv,2, r, 180);
	for(lp=chaninfo->members;lp;lp=lp->next)
	{
		if((n=lp->value.j->nick) && n != nick && (!n->is_oper && (!n->user || !IsAnAdmin(n->user) || n->user->level <= nick->user->level)))
		{
#ifdef HAVE_CRYPTHOST
			mask = getbanmask(n->nick, n->ident, n->crypt, chaninfo->bantype);
#else
			mask = getbanmask(n->nick, n->ident, n->host, chaninfo->bantype);
#endif
			add_ban(chaninfo, mask, r, nick->user->nick, time(NULL), 0, 0);
			csmode(chaninfo, "+b %s", mask);
			cskick(chaninfo->chan, n->numeric, "%s", r);
			free(mask);
		}
	}
	return;
}
